//##############################################################################
// siphon
//
// config.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __CONFIG_H__
#define __CONFIG_H__

#include "common.h"

typedef struct
{
	bool fullscreen;
	int screen_width;
	int screen_height;
	int progress;
	bool music_enabled;
	bool sample_enabled;

	unsigned int milliseconds_per_frame;

	bool player_can_walljump;
	bool player_can_climb;
	bool player_can_jet;
	bool flip_map_horizontally;
	bool flip_water_land;
	bool flip_gravity;
	bool flip_left_right;
	bool flip_rope;
} Config;

extern Config config;

extern void config_initialize();
extern void config_save();

#endif
