//##############################################################################
// siphon
//
// datastructures.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __DATASTRUCTURES_H__
#define __DATASTRUCTURES_H__

// Dictionary implemented as a singly linked list
typedef struct SDict
{
	char * key;
	void * value;
	struct SDict * next;
} SDict;

extern SDict * sdict_add(SDict * dict, const char * key, void * value);
extern SDict * sdict_find(SDict * dict, const char * key);
extern SDict * sdict_free(SDict * dict);
extern SDict * sdict_free_full(SDict * dict, void(*free_func)(void*));

// Singly linked list
typedef struct SList
{
	void * data;
	struct SList * next;
} SList;

typedef int (*slist_compare_func)(void*,void*);

extern SList * slist_add(SList * list, void * data);
extern SList * slist_remove(SList * list, void * data);
extern SList * slist_find(SList * list, slist_compare_func cb, void * userdata);
extern SList * slist_free(SList * list);
extern SList * slist_free_full(SList * list, void(*free_func)(void*));


#endif
