//##############################################################################
// siphon
//
// fixedpoint.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __FIXED_POINT__
#define __FIXED_POINT__

typedef int FIXED_POINT;

#define PRECISION 12
#define HALF_PREC (PRECISION >> 1)

#define TOFIX(a) ((a) << PRECISION)
#define TOINT(a) ((a) >> PRECISION)

#define FIXMUL(a, b) (((a) >> HALF_PREC) * ((b) >> HALF_PREC))
#define FIXDIV(a, b) (((a) << HALF_PREC) / ((b) >> HALF_PREC))

#define L_MUL(a, b) (((a) >> 4) * ((b) >> 8))
#define R_MUL(a, b) (((a) >> 8) * ((b) >> 4))


#endif
