//##############################################################################
// siphon
//
// font.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __FONT_H__
#define __FONT_H__

#include "opengl_helper.h"
#include "vector.h"

typedef struct
{
	int height;
	int * widths;
	float * rights;
	float * lefts;
	float bottom;
	int highestindex;
	GLuint * tex;
} Font;

extern Font * font_create(const char * name, const char * alphabet);
extern void font_destroy(Font * font);
extern void font_draw_text(Font * font, Vector pos, const char * text);
extern void font_draw_dialog(Font *, Vector, Vector size, const char * text);
extern Vector font_measure_text(Font * font, const char * text);


#endif
