//##############################################################################
// siphon
//
// frameratelimiter.c
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#include <SDL.h>

#include "frameratelimiter.h"
#include "config.h"

//##############################################################################
// Static variables
//##############################################################################
static unsigned int m_start_ticks = 0;
static unsigned int m_stop_ticks = 0;

//##############################################################################
// Exported functions
//##############################################################################
void frameratelimiter_start()
{
	m_start_ticks = SDL_GetTicks();
}

void frameratelimiter_stop()
{
	m_stop_ticks = SDL_GetTicks();
}

void frameratelimiter_limit_rate()
{
	unsigned int delta = m_stop_ticks - m_start_ticks;
	if(delta < config.milliseconds_per_frame)
		SDL_Delay(config.milliseconds_per_frame - delta);
}
