//##############################################################################
// siphon
//
// player.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __PLAYER_H__
#define __PLAYER_H__

#include "gameobject.h"
#include "rope.h"
#include "sprite.h"
#include "vector.h"
#include "fixedpoint.h"
#include "registry.h"

typedef enum
{
	LEFT,
	RIGHT
} PlayerDirection;

typedef struct
{
	FIXED_POINT x, y;
	FIXED_POINT xvel, yvel;
	unsigned int lifetime;
} Particle;


typedef struct
{
	GameObject gameobject;
	bool is_dead;
	bool has_finished;
	bool trying_pickup;
	bool previous_pickup;
	bool previous_action;
	bool previous_throw;
	bool previous_jump;
	int aircontrol_lock;
	bool jetting;
	Sprite * sprite;
	GLuint * smoke_particle;
	PlayerDirection direction;
	int ticks;
	unsigned int bubble_count;
	Vector bubbles[256];
	unsigned int particle_count;
	Particle particles[256];
	GameObject * holding;
} Player;

extern GameObject * player_create(const CreateArgs * args);
extern void player_pickup_rope(GameObject * go_player, GameObject * go_rope);

#endif
