//##############################################################################
// siphon
//
// rope.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __ROPE_H__
#define __ROPE_H__

#include "map.h"
#include "sprite.h"
#include "vector.h"
#include "common.h"
#include "fixedpoint.h"
#include "gameobject.h"
#include "registry.h"

typedef struct CableNode
{
	Vector pos;
	struct CableNode * next;
	Map * map;
} CableNode;

typedef struct
{
	GameObject gameobject;
	GameObject * endpoint;
	GameObject * holder;
	CableNode start;
	Sprite * sprite;
	int previous_collide;
} Rope;

extern GameObject * rope_create(const CreateArgs * args);
extern bool rope_has_nodes(GameObject * rope);
extern void rope_attach(GameObject * go_rope, GameObject * attachee);

#endif
