//##############################################################################
// siphon
//
// map.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __MAP_H__
#define __MAP_H__

#include "opengl_helper.h"
#include "vector.h"
#include "common.h"
#include "sound.h"
#include "properties.h"

typedef struct GameObjectPosition
{
	char * name;
	Properties * properties;
	struct GameObjectPosition * next;
} GameObjectPosition;

typedef struct
{
	unsigned int w;
	unsigned int h;
	int underground;
	unsigned int tilesize;
	unsigned int tileshift;
	unsigned int tickcount;
	unsigned int alive_players;
	unsigned int total_players;
	unsigned int finished_players;
	GLfloat * vertex_buffer;
	GLfloat * texcoord_buffer;
	GLuint * vertices_vbo;
	GLuint * texcoords_vbo;
	GLuint * tileset_texture;
	unsigned int * tiles;
	char * mapname;
	Vector surface_size;
	Properties * properties;
	GameObjectPosition * gameobjects;
} Map;

extern Map * map_create(const char * name);
extern void map_destroy(Map * map);
extern void map_draw(Map * map, Vector tile_pos);
extern void map_logic(Map * map);
extern int map_get_tilenum(Map * map, Vector offset);

#endif
