//##############################################################################
// siphon
//
// properties.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __PROPERTIES_H__
#define __PROPERTIES_H__

#include "vector.h"

typedef struct
{
	char * name;
	char * value;
} Property;

typedef struct
{
	unsigned int count;
	unsigned int capacity;
	Property * data;
} Properties;

extern Properties * properties_create();
extern void properties_destroy(Properties * properties);
extern void properties_add(Properties * properties, const char * name,
	const char * value);
extern void properties_add_from_string(Properties * properties, char * buffer);
extern const char * properties_get_value(Properties * properties,
	const char * name);
extern Vector properties_get_vector(Properties * properties, const char * name);
extern int properties_get_int(Properties * properties, const char * name);

#endif
