//##############################################################################
// siphon
//
// registry.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __REGISTRY_H__
#define __REGISTRY_H__

#include "gameobject.h"
#include "fixedpoint.h"
#include "map.h"

typedef void (*AddFunc)(GameObject * gameobject);

typedef struct
{
	Properties * properties;
	Map * map;
	AddFunc addfunc;
} CreateArgs;

typedef GameObject * (*CreateFunc)(const CreateArgs * args);
extern void registry_create(const char *, const CreateArgs * args);
extern bool registry_contains(const char *);
extern void registry_register(const char * name, CreateFunc func);
extern void registry_unregister();

#endif
