//##############################################################################
// siphon
//
// resources.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __RESOURCES_H__
#define __RESOURCES_H__

#include <SDL.h>

#include "opengl_helper.h"
#include "common.h"
#include "sprite.h"

extern void resources_initialize();
extern GLuint * resources_get_gl_image(const char * name);
extern GLuint * resources_create_vbo(GLsizei, void *);
extern void resources_destroy_vbo(GLuint*);
extern SDL_Surface * resources_get_image(const char * name);
extern SpriteInfo * resources_get_spriteinfo(const char * name);
extern void resources_reload();
extern void resources_unload();


typedef struct
{
	unsigned int count;
	char ** items;
} DirectoryList;

typedef bool (*ListFilterFunc)(const char *);

#define DIRECTORY_LIST_DEFAULT_CAPACITY 4

extern DirectoryList * resources_create_list(const char * name, ListFilterFunc);
extern void resources_destroy_list(DirectoryList * list);

#endif
