//##############################################################################
// siphon
//
// sound.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __SOUND_H__
#define __SOUND_H__

#include "common.h"

typedef enum
{
	SOUND_FLIP_SWITCH,
	SOUND_THUMP,
	SOUND_SHOOT,
	SOUND_EXPLODE,
	SOUND_JUMP,
	SOUND_SAMPLE_MAX
} SoundSample;

extern void sound_initialize();
extern void sound_cleanup();
extern void sound_play_sample(SoundSample sample);
extern void sound_play_music(const char * music);
extern bool sound_music_is_playing();
extern bool sound_music_is_paused();
extern void sound_pause_music();
extern void sound_stop_music();
extern void sound_resume_music();

#endif
