//##############################################################################
// siphon
//
// sprite.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __SPRITE_H__
#define __SPRITE_H__

#include "opengl_helper.h"

typedef struct
{
	float left;
	float right;
	float top;
	float bottom;
	int width;
	int height;
} SpriteFrame;

typedef struct
{
	char * name;
	int divisor;
	int frame_count;
	SpriteFrame * frames;
} SpriteAnimation;

typedef struct
{
	GLuint * tex;
	int animation_count;
	SpriteAnimation * animations;
} SpriteInfo;

typedef struct
{
	SpriteAnimation * current_animation;
	SpriteInfo * info;
	int frame_count;
} Sprite;


extern Sprite * sprite_create(const char * name);
extern void sprite_set_animation(Sprite * sprite, const char * name);
extern void sprite_draw(Sprite * sprite, int x, int y);
extern void sprite_destroy(Sprite * sprite);
extern void sprite_destroy_info(SpriteInfo * info);

#endif
