//##############################################################################
// siphon
//
// game.h
//
// Copyright 2010 Maato
//
// Authors:
//    Maato <maato@softwarebakery.com>
//
// This program is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 3, as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranties of
// MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
// PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.
//##############################################################################
#ifndef __GAME_H__
#define __GAME_H__

#include "main.h"
#include "gameobject.h"

typedef enum
{
	GAMESTATUS_NONE,
	GAMESTATUS_PAUSED,
	GAMESTATUS_COMPLETED_LEVEL,
	GAMESTATUS_CANCELED,
	GAMESTATUS_DIED,
} GameStatus;

typedef void (*collider_callback)(GameObject*,GameObject*);

extern void game_load_map(const char * name);
extern bool game_is_on_screen(GameObject * gameobject);
extern Uint8 * game_get_keystate(GameObject * gameobject);
extern void game_do_colliders(GameObject * gameobject, collider_callback cb);
extern void game_set_message(const char * text);
extern GameStatus game_get_status();

#endif
